% This module contains some auxiliar predicates. 

:- module(aux, [qsort/2, term_at/3, give_name/2], []).

:- use_module(library(lists), [append/3] ).

:- include(operators).

% En principio solo se usa con listas de tamao 1, por lo que es 
% equivalente a arg/3.

term_at(Term,[],Term).
term_at(Term,[Pos|Poss],Subterm):-
	arg(Pos,Term,Term2),
	term_at(Term2,Poss,Subterm).


% Imported from trad.pl

give_name([],_).  % Da nombre a las variables libres: R0,R1,...
give_name([var(V)|R],N):-
	\+var(V),!,
	give_name(R,N).
give_name([var(V)|R],N):- % Si la variable estaba libre la ponemos como 
	name(N,Nlist),      % loc(Rn) para indicar que al escribirla no 
	Nlist2=[82|Nlist],  % debemos poner la V delante.
	name(V2,Nlist2),
	V=loc(V2),
	N1 is N+1,
	give_name(R,N1).

%%%%%%%%%


regla_mayor(prolog(_,_)-_,block(_)):-!.
regla_mayor(block(B1),block(B2)):-!,
	B1@>B2.
regla_mayor(prolog(Head1,_Body1)-Poss1,prolog(Head2,_Body2)-Poss2):-!,
	functor(Head1,F1,_),
	functor(Head2,F2,_),
	(F1,Poss1)@>(F2,Poss2).
regla_mayor(block(_),prolog(_,_)-_):-!,fail.
regla_mayor(_Tree1-R1s,_Tree2-R2s):- % Para comparar los arboles or 
	R1s@>R2s.

split2(_,[],[],[]).
split2(Piv,[L|Ls],[L|Menores],Mayores):-
	% Piv@>L,!,
	regla_mayor(Piv,L),!,
	split2(Piv,Ls,Menores,Mayores).
split2(Piv,[L|Ls],Menores,[L|Mayores]):-
	split2(Piv,Ls,Menores,Mayores).

qsort([],[]).
qsort([X],[X]):-!.
qsort([X|Xs],Rs):-
	split2(X,Xs,Menores,Mayores),
	qsort(Menores,MenoresOrd),qsort(Mayores,MayoresOrd),
	append(MenoresOrd,[X|MayoresOrd],Rs).


%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

