% symtabold.pl
% Interfaz de acceso a la base de datos

:-module(symtabold, [delete/2, deleteobj/1, create/2, lookup/3,
	          allobj/2, update/3, insert/3, link/3]).

%

:- use_module(library(aggregates), [findall/3]).
:- use_module(library(dynamic),    [assert/1, retractall/1]).

% 

:- include(operators).


% Private dynamics

:- dynamic(symlink/3).


% OJO! : delete/2 slo se invoca 1 vez fuera de aqu
%
%

delete(X,Y):-
	nonvar(X),nonvar(Y),
	retractall(symtab(X,Y,_)),!.

deleteobj(X):-
	retractall(symtab(X,_,_)),!.

% OJO : aparentemente no usado 
checkobj(Object,Class):-
	symtab(Object,class,Class),!.

%
% create(Object,Class)<-
%       Create a new object Object with class Class.
%

create(Object,Class):-
	\+symtab(Object,class,Class),
	assert(symtab(Object,class,Class)),!.

%
% lookup(Object,Attribute,Value) <-
%
%

lookup(X,Y,Z):-
	symtab(X,Y,Z).
%
% allobj(Class,List) <-
%       List contains all the object names belonging to Class
%

allobj(Class,List):-
	findall(X,symtab(X,class,Class),List).

update(Object,Attribute,Value):-
	delete(Object,Attribute),
	insert(Object,Attribute,Value).

	
insert(Object,Attribute,Value):-
	\+ lookup(Object,Attribute,_),
	assert(symtab(Object,Attribute,Value)),!.

link(R,Object1,Object2):-
	lookup(Object1,class,_),
	lookup(Object2,class,_),
	assert(symlink(R,Object1,Object2)).




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Deprecated predicates.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% % no usado
% updatef(Object,Attribute,Function,NewValue):-
% 	lookup(Object,Attribute,OldValue),
% 	delete(Object,Attribute),
% 	apply(Function,[OldValue,NewValue]),
% 	insert(Object,Attribute,NewValue).

% ----------------------------------------------------------------------------------------

% deref(X,T,[X:T|_]):-!.

% deref(X,T,[_|Rest]):-!,deref(X,T,Rest).

% deref(X,T,Xs):-var(Xs),var(Ys),Xs=[X:T|Ys].


% ----------------------------------------------------------------------------------------

% query(R,Object1,Object2):-
% 	lookup(Object1,class,_),
% 	lookup(Object2,class,_),
% 	symlink(R,Object1,Object2).

% queryall1(R,Object,List):-
% 	lookup(Object,class,_),
% 	findall(X,symlink(R,Object,X),List).

% queryall2(R,Object,List):-
% 	lookup(Object,class,_),
% 	findall(X,symlink(R,Object,X),List).

% ----------------------------------------------------------------------------------------


% %
% % lookup2(Attrib,Object,Value) <-
% %     well suited for apply
% %
% % no usado :(

% % lookup2(X,Y,Z):-
% % 	symtab(Y,X,Z).

% %
% % lookupc(Class,Attribute,List) <-
% %       
% % NO USADO
% %

% lookupc(Class,Attribute,List):-
% 	findall(X,(symtab(S,class,Class),symtab(S,Attribute,X)),List).


% ----------------------------------------------------------------------------------------


% Convert((A->B),(C->D),Env):-!,
% 	convert(A,C,Env),
% 	convert(B,D,Env).

% convert(var(X),V,Env):-!,
% 	deref(X,V,Env).
	
% convert(T,T1,Env):-
% 	T=..[X|Args],
% 	convertlist(Args,Xs,Env),
% 	T1=..[X|Xs].

% convertlist([X|Xs],[Y|Ys],Env):-!,
% 	convert(X,Y,Env),
% 	convertlist(Xs,Ys,Env).

%convertlist([],[],_).



%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:


%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

